import java.util.*;
import java.io.*;

public class main {

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        
        String prvaLinija = br.readLine();
        String[] prviDelovi = prvaLinija.split(" ");
        long a = Long.parseLong(prviDelovi[0]); // broj dana
        long b = Long.parseLong(prviDelovi[1]); // upiti

        
        long[] d = new long[(int) a];
        long[] p = new long[(int) a];

        for (int x = 0; x < a; x++) {
            String ulaz = br.readLine();
            String[] delovi = ulaz.split(" ");
            d[x] = Long.parseLong(delovi[0]); // v dan
            p[x] = Long.parseLong(delovi[1]); // paketi
        }

      
        long[] up = new long[(int) b];
        for (int c = 0; c < b; c++) {
            up[c] = Long.parseLong(br.readLine());
        }

        // Skupljam ukupne pakete
        long[] ukupno = new long[(int) a];
        ukupno[0] = p[0];
        for (int i = 1; i < a; i++) {
            ukupno[i] = ukupno[i - 1] + p[i];
        }

        // Ovo dole su odgovori na upite
        String sve = ""; 

        for (int z = 0; z < b; z++) {
            long trenutni = up[z];
            int poslednji = nadjiDan(d, trenutni);

            long ukupnoPaket = 0;
            if (poslednji != -1) {
                ukupnoPaket = ukupno[poslednji];
            }

            long danovi = trenutni - d[0] + 1;

            if (ukupnoPaket < danovi) {
                sve = sve + ukupnoPaket + "\n"; 
            } else {
                sve = sve + danovi + "\n";
            }
        }

        
        System.out.println(sve);
    }

    // trazenje dana
    public static int nadjiDan(long[] niz, long broj) {
        int l = 0;
        int r = niz.length - 1;
        int izlaz = -1;

        while (l <= r) {
            int srednji = (l + r) / 2; 
            if (niz[srednji] <= broj) {
                izlaz = srednji;
                l = srednji + 1;
            } else {
                r = srednji - 1;
            }
        }

        return izlaz;
    }
}